<template functional>
  <div
    :ref="data.ref"
    class="a-stack-l"
    :class="[data.class, data.staticClass]"
    :style="[data.style, data.staticStyle]"
    v-bind="data.attrs"
    v-on="listeners"
  >
    <!--
      @slot The stacked elements.
    -->
    <slot />
  </div>
</template>

<script>
export default {
  name: 'AStackL',
};
</script>

<style>
/* Basic Stack */
.a-stack-l {
  --a-stack-l--def-space-y: 1.5rem; /* theme('space.6') */

  display: flex;
  flex-direction: column;
  justify-content: flex-start;
}
.a-stack-l:not(.a-stack-l--recursive):not(.reset) > * {
  margin-top: 0;
  margin-bottom: 0;
}
.a-stack-l:not(.a-stack-l--recursive):not(.reset) > * + * {
  margin-top: var(--a-stack-l--space-y, var(--a-stack-l--def-space-y));
}

/* Recursive Stack */
.a-stack-l.a-stack-l--recursive * {
  margin-top: 0;
  margin-bottom: 0;
}
.a-stack-l.a-stack-l--recursive * + * {
  margin-top: var(--a-stack-l--space-y, var(--a-stack-l--def-space-y));
}

/* Splitted Stack */
[class*='a-stack-l--splitAfter']:only-child {
  height: 100%;
}
.a-stack-l.a-stack-l--splitAfter-1 > :nth-child(1),
.a-stack-l.a-stack-l--splitAfter-2 > :nth-child(2),
.a-stack-l.a-stack-l--splitAfter-3 > :nth-child(3),
.a-stack-l.a-stack-l--splitAfter-4 > :nth-child(4),
.a-stack-l.a-stack-l--splitAfter-5 > :nth-child(5),
.a-stack-l.a-stack-l--splitAfter-6 > :nth-child(6) {
  margin-bottom: auto;
}
</style>
